DescriptorProtos.FieldDescriptorProtoOrBuilder
Date: 2017-07-08

com.google.protobuf

## Interface DescriptorProtos.FieldDescriptorProtoOrBuilder

- All Superinterfaces:
    MessageLiteOrBuilder, MessageOrBuilder
  All Known Implementing Classes:
    DescriptorProtos.FieldDescriptorProto, DescriptorProtos.FieldDescriptorProto.Builder
  Enclosing class:
    DescriptorProtos

      public static interface DescriptorProtos.FieldDescriptorProtoOrBuilder
      extends MessageOrBuilder

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `getDefaultValue()` For numeric types, contains the original text representation of the value.
    `ByteString` | `getDefaultValueBytes()` For numeric types, contains the original text representation of the value.
    `java.lang.String` | `getExtendee()` For extensions, this is the name of the type being extended.
    `ByteString` | `getExtendeeBytes()` For extensions, this is the name of the type being extended.
    `java.lang.String` | `getJsonName()` JSON name of this field.
    `ByteString` | `getJsonNameBytes()` JSON name of this field.
    `DescriptorProtos.FieldDescriptorProto.Label` | `getLabel()` `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`
    `java.lang.String` | `getName()` `optional string name = 1;`
    `ByteString` | `getNameBytes()` `optional string name = 1;`
    `int` | `getNumber()` `optional int32 number = 3;`
    `int` | `getOneofIndex()` If set, gives the index of a oneof in the containing type's oneof_decl list.
    `DescriptorProtos.FieldOptions` | `getOptions()` `optional .google.protobuf.FieldOptions options = 8;`
    `DescriptorProtos.FieldOptionsOrBuilder` | `getOptionsOrBuilder()` `optional .google.protobuf.FieldOptions options = 8;`
    `DescriptorProtos.FieldDescriptorProto.Type` | `getType()` If type_name is set, this need not be set.
    `java.lang.String` | `getTypeName()` For message and enum types, this is the name of the type.
    `ByteString` | `getTypeNameBytes()` For message and enum types, this is the name of the type.
    `boolean` | `hasDefaultValue()` For numeric types, contains the original text representation of the value.
    `boolean` | `hasExtendee()` For extensions, this is the name of the type being extended.
    `boolean` | `hasJsonName()` JSON name of this field.
    `boolean` | `hasLabel()` `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`
    `boolean` | `hasName()` `optional string name = 1;`
    `boolean` | `hasNumber()` `optional int32 number = 3;`
    `boolean` | `hasOneofIndex()` If set, gives the index of a oneof in the containing type's oneof_decl list.
    `boolean` | `hasOptions()` `optional .google.protobuf.FieldOptions options = 8;`
    `boolean` | `hasType()` If type_name is set, this need not be set.
    `boolean` | `hasTypeName()` For message and enum types, this is the name of the type.

    - ### Methods inherited from interface com.google.protobuf.MessageOrBuilder

      `findInitializationErrors, getAllFields, getDefaultInstanceForType, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

    - ### Methods inherited from interface com.google.protobuf.MessageLiteOrBuilder

      `isInitialized`

- - ### Method Detail

    - #### hasName

          boolean hasName()

      `optional string name = 1;`

    - #### getName

          java.lang.String getName()

      `optional string name = 1;`

    - #### getNameBytes

          ByteString getNameBytes()

      `optional string name = 1;`

    - #### hasNumber

          boolean hasNumber()

      `optional int32 number = 3;`

    - #### getNumber

          int getNumber()

      `optional int32 number = 3;`

    - #### hasLabel

          boolean hasLabel()

      `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`

    - #### getLabel

          DescriptorProtos.FieldDescriptorProto.Label getLabel()

      `optional .google.protobuf.FieldDescriptorProto.Label label = 4;`

    - #### hasType

          boolean hasType()

           If type_name is set, this need not be set.  If both this and type_name
           are set, this must be one of TYPE_ENUM, TYPE_MESSAGE or TYPE_GROUP.

      `optional .google.protobuf.FieldDescriptorProto.Type type = 5;`

    - #### getType

          DescriptorProtos.FieldDescriptorProto.Type getType()

           If type_name is set, this need not be set.  If both this and type_name
           are set, this must be one of TYPE_ENUM, TYPE_MESSAGE or TYPE_GROUP.

      `optional .google.protobuf.FieldDescriptorProto.Type type = 5;`

    - #### hasTypeName

          boolean hasTypeName()

           For message and enum types, this is the name of the type.  If the name
           starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
           rules are used to find the type (i.e. first the nested types within this
           message are searched, then within the parent, on up to the root
           namespace).

      `optional string type_name = 6;`

    - #### getTypeName

          java.lang.String getTypeName()

           For message and enum types, this is the name of the type.  If the name
           starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
           rules are used to find the type (i.e. first the nested types within this
           message are searched, then within the parent, on up to the root
           namespace).

      `optional string type_name = 6;`

    - #### getTypeNameBytes

          ByteString getTypeNameBytes()

           For message and enum types, this is the name of the type.  If the name
           starts with a '.', it is fully-qualified.  Otherwise, C++-like scoping
           rules are used to find the type (i.e. first the nested types within this
           message are searched, then within the parent, on up to the root
           namespace).

      `optional string type_name = 6;`

    - #### hasExtendee

          boolean hasExtendee()

           For extensions, this is the name of the type being extended.  It is
           resolved in the same manner as type_name.

      `optional string extendee = 2;`

    - #### getExtendee

          java.lang.String getExtendee()

           For extensions, this is the name of the type being extended.  It is
           resolved in the same manner as type_name.

      `optional string extendee = 2;`

    - #### getExtendeeBytes

          ByteString getExtendeeBytes()

           For extensions, this is the name of the type being extended.  It is
           resolved in the same manner as type_name.

      `optional string extendee = 2;`

    - #### hasDefaultValue

          boolean hasDefaultValue()

           For numeric types, contains the original text representation of the value.
           For booleans, "true" or "false".
           For strings, contains the default text contents (not escaped in any way).
           For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
           TODO(kenton):  Base-64 encode?

      `optional string default_value = 7;`

    - #### getDefaultValue

          java.lang.String getDefaultValue()

           For numeric types, contains the original text representation of the value.
           For booleans, "true" or "false".
           For strings, contains the default text contents (not escaped in any way).
           For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
           TODO(kenton):  Base-64 encode?

      `optional string default_value = 7;`

    - #### getDefaultValueBytes

          ByteString getDefaultValueBytes()

           For numeric types, contains the original text representation of the value.
           For booleans, "true" or "false".
           For strings, contains the default text contents (not escaped in any way).
           For bytes, contains the C escaped value.  All bytes >= 128 are escaped.
           TODO(kenton):  Base-64 encode?

      `optional string default_value = 7;`

    - #### hasOneofIndex

          boolean hasOneofIndex()

           If set, gives the index of a oneof in the containing type's oneof_decl
           list.  This field is a member of that oneof.

      `optional int32 oneof_index = 9;`

    - #### getOneofIndex

          int getOneofIndex()

           If set, gives the index of a oneof in the containing type's oneof_decl
           list.  This field is a member of that oneof.

      `optional int32 oneof_index = 9;`

    - #### hasJsonName

          boolean hasJsonName()

           JSON name of this field. The value is set by protocol compiler. If the
           user has set a "json_name" option on this field, that option's value
           will be used. Otherwise, it's deduced from the field's name by converting
           it to camelCase.

      `optional string json_name = 10;`

    - #### getJsonName

          java.lang.String getJsonName()

           JSON name of this field. The value is set by protocol compiler. If the
           user has set a "json_name" option on this field, that option's value
           will be used. Otherwise, it's deduced from the field's name by converting
           it to camelCase.

      `optional string json_name = 10;`

    - #### getJsonNameBytes

          ByteString getJsonNameBytes()

           JSON name of this field. The value is set by protocol compiler. If the
           user has set a "json_name" option on this field, that option's value
           will be used. Otherwise, it's deduced from the field's name by converting
           it to camelCase.

      `optional string json_name = 10;`

    - #### hasOptions

          boolean hasOptions()

      `optional .google.protobuf.FieldOptions options = 8;`

    - #### getOptions

          DescriptorProtos.FieldOptions getOptions()

      `optional .google.protobuf.FieldOptions options = 8;`

    - #### getOptionsOrBuilder

          DescriptorProtos.FieldOptionsOrBuilder getOptionsOrBuilder()

      `optional .google.protobuf.FieldOptions options = 8;`